﻿using System.Collections.Generic;

namespace CheckoutKata
{
	public class Checkout
	{
		private readonly IProducts _products;
		private readonly Dictionary<string, int> _scannedProducts = new Dictionary<string, int>();

		public Checkout(IProducts products)
		{
			_products = products;
		}

		public void Scan(string sku)
		{
			if (_scannedProducts.ContainsKey(sku))
				_scannedProducts[sku]++;
			else
				_scannedProducts.Add(sku, 1);
		}

		public int GetTotalPrice()
		{
			var total = 0;
			foreach (var scan in _scannedProducts)
			{
				var product = _products.GetBySKU(scan.Key);
				total += product.GetPriceForQuantity(scan.Value);
			}

			return total;
		}
	}
}
