﻿namespace CheckoutKata
{
	public class SpecialPriceProduct : Product
	{
		private readonly int _specialPrice;
		private readonly int _specialPriceMultiplier;

		public SpecialPriceProduct(int price, int specialPrice, int specialPriceMultiplier) : base(price)
		{
			_specialPrice = specialPrice;
			_specialPriceMultiplier = specialPriceMultiplier;
		}

		public override int GetPriceForQuantity(int quantity)
		{
			var quantityForSpecialPrice = quantity / _specialPriceMultiplier;
			var quantityForNormalPrice = quantity % _specialPriceMultiplier;

			return quantityForSpecialPrice * _specialPrice + base.GetPriceForQuantity(quantityForNormalPrice);
		}
	}
}